<?php

#error_reporting(E_ALL);
#ini_set('display_errors', 'On');

include $_SERVER['DOCUMENT_ROOT']."/microdraw/php/base.php";
$connection=mysqli_connect($dbhost, $dbuser, $dbpass,$dbname) or die("MySQL Error 1: " . mysql_error());
mysqli_set_charset($connection, "utf8");

// For debugging
/* file_put_contents('php://stderr', print_r($foo, TRUE)); */

if(isset($_GET["action"])) {
	$action=$_GET;
} else {
	// POST
	if(isset($_POST["action"])) {
		$action=$_POST;
	} else {
		// Decode JSON
		$action = json_decode(file_get_contents("php://input"));
		$action = get_object_vars($action);
	}
}

switch($action["action"])
{
	case "save":
		save($action);
		break;
	case "load":
		load($action);
		break;
	case "load_last":
		loadLast($action);
		break;
	case "load_last_multiple":
		loadLastMultiple($action);
		break;
	case "remote_address":
		remote_address();
		break;
}

function save($args)
{
	global $connection;
	global $dbname;
	
	header("Access-Control-Allow-Origin: *");

	$q="INSERT INTO ".$dbname.".KeyValue (myOrigin, myKey, myValue) VALUES('"
		.$args["origin"]."','"
		.$args["key"]."','"
		.mysqli_real_escape_string($connection,$args["value"])."')";
	$result = mysqli_query($connection,$q);

	header('Content-Type: application/json');
	if($result) {
		$response["result"]="success";
	} else {
		$response["result"]="error";
		$response["description"]=mysqli_error($connection);
	}
	echo json_encode($response);
}

function load($args)
{
	global $connection;
	global $dbname;
	$arr=array();
	
	header("Access-Control-Allow-Origin: *");
	
	$q="SELECT * FROM ".$dbname.".KeyValue WHERE "
		." myOrigin = '".$args["origin"]."' AND"
		." myKey = '".$args["key"]."'";
	$result = mysqli_query($connection,$q);

	while($row = mysqli_fetch_assoc($result)) {
		if($row["myValue"])
		{
			//$row["myValue"]=json_decode($row["myValue"]);
			array_push($arr,$row);
		}
	}

	header('Content-Type: application/text');
	echo json_encode($arr);

	mysqli_free_result($result);
}
function loadLast($args)
{
	global $connection;
	global $dbname;
	
	header("Access-Control-Allow-Origin: *");
	
	$q="SELECT * FROM ".$dbname.".KeyValue WHERE "
		." myOrigin = '".$args["origin"]."' AND"
		." myKey = '".$args["key"]."'"
		." ORDER BY myTimestamp DESC LIMIT 1";
	$result = mysqli_query($connection,$q);
	if(mysqli_num_rows($result)>0) {
		header('Content-Type: application/text');
		$row = mysqli_fetch_assoc($result);
		echo json_encode($row);
	}
	mysqli_free_result($result);
}
function loadLastMultiple($args)
{
	global $connection;
	global $dbname;
	$origins=$args["origin"];
	$arr=array();
	
	header("Access-Control-Allow-Origin: *");
	header('Content-Type: application/json');
	
	// Loop over all origins we received
	foreach ($origins as $origin) {
		/* file_put_contents('php://stderr', print_r($origin, TRUE)); */
		$q="SELECT * FROM ".$dbname.".KeyValue WHERE "
			." myOrigin = '".$origin."' AND"
			." myKey = '".$args["key"]."'"
			." ORDER BY myTimestamp DESC LIMIT 1";
		$result = mysqli_query($connection,$q);
		if(mysqli_num_rows($result)>0) {
			header('Content-Type: application/text');
			$row = mysqli_fetch_assoc($result);
			array_push($arr,$row);
		}
		mysqli_free_result($result);
	}
	echo json_encode($arr);
}
function remote_address()
{
	header("Access-Control-Allow-Origin: *");

	echo $_SERVER['REMOTE_ADDR'];
}
?>
