#!/usr/bin/env bash
# Start server on remote machine

USER=schiffer1
HOST=jureca10.fz-juelich.de
COMMAND='cd /p/home/jusers/schiffer1/jureca/project_jinm16/atlasui/atlas_controller/; source load_modules.sh; source venv/bin/activate; export PYTHONPATH=`pwd`:$PYTHONPATH; python atlas_controller/app.py'
RECONNECT=60

while true
do
	echo "Connecting"
	ssh ${USER}@${HOST} -t "bash -cl '${COMMAND}'"
	retval=$?
	# Check for timeout
	if [[ ${retval} -ne 0 ]]; then
		echo "$(date) Could not establish connection to ${HOST}. Will try again in ${RECONNECT} seconds..."
		sleep ${RECONNECT}
	fi
done
